// Copyright 2010 Simon Massey. All rights reserved. net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.net.sf.chex4j is licensed under the terms of the Eclipse Public License v1.0, as defined by the attached file LICENSE-ECLIPSE.txt.
package net.sf.chex4j;

import java.io.IOException;
import java.lang.instrument.ClassFileTransformer;
import java.lang.instrument.Instrumentation;

import net.sf.chex4j.internal.ChexBase;

/**
 * This class is simply the entry point to a -javaagent which performs
 * transformations on loaded classes.
 * 
 * @author simon
 */
public class ChexJavaAgent extends ChexBase implements ClassFileTransformer {

	public ChexJavaAgent(Arguments arguments) {
		super(arguments);
	}

	/**
	 * @param agentArguments
	 *            net.sf.chex4j...,com.yourcompany.proprietry...,dir=target/chex4j
	 * @throws IOException 
	 */
	public static void premain(String agentArguments,
			Instrumentation instrumentation) throws IOException {
		if (null == agentArguments || agentArguments.equals("")) {
			throw new AssertionError("FATAL chex4j javaagent: no packge list specified. Will do nothing.");
		}
		Arguments arguments = parseArguments(agentArguments);
		instrumentation.addTransformer(new ChexJavaAgent(arguments));
		java.lang.System.out.println("chex4j javaagent has finished premain setup steps.");
	}
}
